#if !defined (local_h)
#define	local_h

#if defined (MIXED_UNICODE_ANSI)
#undef	UNICODE
#undef	_UNICODE
#endif

#include <windows.h>
#include <tchar.h>
#include <assert.h>

#define	NELEMENTS(array)	(sizeof array / sizeof array[0])

#if defined (MIXED_UNICODE_ANSI)
/*	MIXED UNICODE AND ANSI */
#define	MYTEXT(x)			L ## x
typedef LPWSTR				LPMYSTR ;
typedef	LPCWSTR				LPCMYSTR ;
typedef wchar_t				MYCHAR ;

#define	MyRegCreateKeyEx(a,b,c,d,e,f,g,h,i)	RegCreateKeyExW((a),(b),(c),(d),(e),(f),(g),(h),(i))
#define	MyRegOpenKeyEx(a,b,c,d,e)			RegOpenKeyExW((a),(b),(c),(d),(e))
#define	MyRegEnumValue(a,b,c,d,e,f,g,h)		RegEnumValueW((a),(b),(c),(d),(e),(f),(g),(h))
#define	MyRegQueryValueEx(a,b,c,d,e,f)		RegQueryValueExW((a),(b),(c),(d),(e),(f))
#define	MyRegSetValueEx(a,b,c,d,e,f)		RegSetValueExW((a),(b),(c),(d),(e),(f))
#define	MyRegDeleteValue(a,b)				RegDeleteValueW((a),(b))
#define	MyRegCloseKey(a)					RegCloseKey((a))

#define	Mywsprintf							wsprintfW
#define	Mywvsprintf(a,b,c)					wvsprintfW((a),(b),(c))
#define	Mylstrlen(a)						lstrlenW((a))
#define	Mylstrcpy(a,b)						lstrcpyW((a),(b))
#define	Mylstrcpyn(a,b,c)					lstrcpynW((a),(b),(c))
#define	Mylstrcmp(a,b)						lstrcmpW((a),(b))
#define	Mylstrcmpn(a,b,c)					lstrcmpnW((a),(b),(c))
#define	MyExpandEnvironmentStrings(a,b,c)	ExpandEnvironmentStringsW((a),(b),(c))

#define	MySendMessage(a,b,c,d)				SendMessageW((a),(b),(c),(d))
#define	MyOutputDebugString(a)				OutputDebugStringW((a))
#define	MyDialogBoxParam(a,b,c,d,e)			DialogBoxParamW((a),(b),(c),(d),(e))
#define	MySetWindowText(a,b)				SetWindowTextW((a),(b))
#define	MyGetWindowText(a,b,c)				GetWindowTextW((a),(b),(c))
#define	MyGetDlgItemText(a,b,c,d)			GetDlgItemTextW((a),(b),(c),(d))

#define	MYLV_COLUMN							LV_COLUMNW
#define	MYLVITEM							LVITEMW
#define	MYLVFINDINFO						LVFINDINFOW

#define	MyListView_GetItem(hwnd,pitem)		\
	(BOOL)MySendMessage((hwnd),LVM_GETITEMW,0,(LPARAM)(MYLVITEM*)(pitem))
#define	MyListView_SetItem(hwnd,pitem)		\
	(BOOL)MySendMessage((hwnd),LVM_SETITEMW,0,(LPARAM)(const MYLVITEM*)(pitem))
#define	MyListView_InsertItem(hwnd,pitem)	\
	(int)MySendMessage((hwnd),LVM_INSERTITEMW,0,(LPARAM)(const MYLVITEM*)(pitem))
#define	MyListView_DeleteItem(hwnd,i)		\
	(BOOL)MySendMessage((hwnd),LVM_DELETEITEM,(WPARAM)(int)(i),0L)
#define	MyListView_DeleteAllItems(hwnd)		\
	(BOOL)MySendMessage((hwnd),LVM_DELETEALLITEMS,0,0L)
#define	MyListView_FindItem(hwnd,iStart,plvfi)	\
	(int)MySendMessage((hwnd),LVM_FINDITEMW,(WPARAM)(int)(iStart), (LPARAM)(const MYLVFINDINFO*)(plvfi))
#define	MyListView_SetItemPosition(hwndLV,i,x,y)	\
	(BOOL)MySendMessage((hwndLV),LVM_SETITEMPOSITION,(WPARAM)(int)(i),MAKELPARAM((x), (y)))
#define	MyListView_GetItemPosition(hwndLV,i,ppt)	\
	(BOOL)MySendMessage((hwndLV),LVM_GETITEMPOSITION,(WPARAM)(int)(i),(LPARAM)(POINT *)(ppt))
#define	MyListView_GetStringWidth(hwnd,psz)	\
	(int)MySendMessage((hwnd), LVM_GETSTRINGWIDTHW, 0, (LPARAM)(LPCMYSTR)(psz))
#define	MyListView_HitTest(hwndLV,pinfo)	\
	(int)MySendMessage((hwndLV),LVM_HITTEST, 0, (LPARAM)(LV_HITTESTINFO *)(pinfo))
#define	MyListVew_GetColumn(hwnd,iCol,pcol)	\
	(BOOL)MySendMessage((hwnd),LVM_GETCOLUMNW,(WPARAM)(int)(iCol),(LPARAM)(MYLV_COLUMN *)(pcol))
#define	MyListView_SetColumn(hwnd,iCol,pcol)	\
	(BOOL)MySendMessage((hwnd),LVM_SETCOLUMNW,(WPARAM)(int)(iCol),(LPARAM)(const MYLV_COLUMN*)(pcol))
#define	MyListView_InsertColumn(hwnd,iCol,pcol)	\
	(int)MySendMessage((hwnd),LVM_INSERTCOLUMNW,(WPARAM)(int)(iCol),(LPARAM)(const MYLV_COLUMN*)(pcol))
#define	MyListView_GetColumnWidth(hwnd,iCol)	\
	(int)MySendMessage((hwnd),LVM_GETCOLUMNWIDTH,(WPARAM)(int)(iCol), 0)
#define	MyListView_SetColumnWidth(hwnd,iCol,cx)	\
	(BOOL)MySendMessage((hwnd),LVM_SETCOLUMNWIDTH,(WPARAM)(int)(iCol), MAKELPARAM((cx),0))
#define	MyListView_CreateDragImage(hwnd,i,lpptUpLeft)	\
	(HIMAGELIST)MySendMessage((hwnd), LVM_CREATEDRAGIMAGE, (WPARAM)(int)(i), (LPARAM)(LPPOINT)(lpptUpLeft))
#define	MyListView_Update(hwndLV,i)	\
	(BOOL)MySendMessage((hwndLV), LVM_UPDATE, (WPARAM)(i), 0L)
#define	MyListView_SetItemState(hwnd,i,data,mask)	{	\
	MYLVITEM	mylvi ;	\
	mylvi.stateMask	= (mask) ;	\
	mylvi.state		= (data) ;	\
	MySendMessage((hwnd), LVM_SETITEMSTATE, (WPARAM)(i), (LPARAM)(MYLVITEM *)&mylvi) ;	\
}
#define	MyListView_GetItemText(hwndLV,i,iSubItem_,pszText_,cchTextMax_)	{\
		MYLVITEM	mylvi ;	\
		mylvi.iSubItem		= (iSubItem_) ;	\
		mylvi.cchTextMax	= (cchTextMax_) ;	\
		mylvi.pszText		= (pszText_) ;	\
		MySendMessage((hwndLV),LVM_GETITEMTEXTW,(WPARAM)(i),(LPARAM)(MYLVITEM *)&mylvi) ;	\
	}
#define	MyListView_SetItemText(hwndLV,i,iSubItem_,pszText_)	{	\
		MYLVITEM	mylvi ;	\
		mylvi.iSubItem	= (iSubItem_) ;	\
		mylvi.pszText	= (pszText_) ;	\
		MySendMessage ((hwndLV), LVM_SETITEMTEXTW, (WPARAM)(i), (LPARAM)(MYLVITEM*)&mylvi) ; \
	}
#define	MyListView_SetItemCount(hwndLV,cItems)	\
	MySendMessage((hwndLV), LVM_SETITEMCOUNT, (WPARAM)(cItems), 0)
#define	MyListView_SortItems(hwndLV,_pfnCompare,_lPrm)	\
	(BOOL)MySendMessage((hwndLV),LVM_SORTITEMS,(WPARAM)(LPARAM)(_lPrm),(LPARAM)(PFNLVCOMPARE)(_pfnCompare))
#define	MyListView_SetExtendedListViewStyle(hwndLV,dw)	\
	(DWORD)MySendMessage((hwndLV),LVM_SETEXTENDEDLISTVIEWSTYLE,0,(dw))
#define	MyListView_SetExtendedListViewStyleEx(hwndLV,dwMask,dw)	\
	(DWORD)MySendMessage((hwndLV),LVM_SETEXTENDEDLISTVIEWSTYLE,(dwMask),(dw))
#define	MyListView_GetSelectionMark(hwnd)	\
	(int)MySendMessage((hwnd),LVM_GETSELECTIONMARK,0,0)
#define	MyListView_SetSelectionMark(hwnd,i)	\
	(int)MySendMessage((hwnd),LVM_SETSELECTIONMARK,0,(LPARAM)(i))
#define	MyListView_GetItemCount(hwnd) \
	(int)MySendMessage((hwnd),LVM_GETITEMCOUNT, 0, 0L)

#else
/*	UNICODE or ANSI */
#define	MYTEXT(x)			TEXT(x)
typedef LPTSTR				LPMYSTR ;
typedef	LPCTSTR				LPCMYSTR ;
typedef TCHAR				MYCHAR ;

#define	MyRegCreateKeyEx(a,b,c,d,e,f,g,h,i)	RegCreateKeyEx((a),(b),(c),(d),(e),(f),(g),(h),(i))
#define	MyRegOpenKeyEx(a,b,c,d,e)			RegOpenKeyEx((a),(b),(c),(d),(e))
#define	MyRegEnumValue(a,b,c,d,e,f,g,h)		RegEnumValue((a),(b),(c),(d),(e),(f),(g),(h))
#define	MyRegQueryValueEx(a,b,c,d,e,f)		RegQueryValueEx((a),(b),(c),(d),(e),(f))
#define	MyRegSetValueEx(a,b,c,d,e,f)		RegSetValueEx((a),(b),(c),(d),(e),(f))
#define	MyRegDeleteValue(a,b)				RegDeleteValue((a),(b))
#define	MyRegCloseKey(a)					RegCloseKey((a))

#define	Mywsprintf							wsprintf
#define	Mywvsprintf(a,b,c)					wvsprintf((a),(b),(c))
#define	Mylstrlen(a)						lstrlen((a))
#define	Mylstrcpy(a,b)						lstrcpy((a),(b))
#define	Mylstrcpyn(a,b,c)					lstrcpyn((a),(b),(c))
#define	Mylstrcmp(a,b)						lstrcmp((a),(b))
#if defined (UNICODE) || defined (_UNICODE)
#define	Mylstrcmpn(a,b,c)					lstrcmpnW((a),(b),(c))
#else
#define	Mylstrcmpn(a,b,c)					lstrcmpnA((a),(b),(c))
#endif
#define	MyExpandEnvironmentStrings(a,b,c)	ExpandEnvironmentStrings((a),(b),(c))

#define	MySendMessage(a,b,c,d)				SendMessage((a),(b),(c),(d))
#define	MyOutputDebugString(a)				OutputDebugString((a))
#define	MyDialogBoxParam(a,b,c,d,e)			DialogBoxParam((a),(b),(c),(d),(e))
#define	MySetWindowText(a,b)				SetWindowText((a),(b))
#define	MyGetWindowText(a,b,c)				GetWindowText((a),(b),(c))
#define	MyGetDlgItemText(a,b,c,d)			GetDlgItemText((a),(b),(c),(d))

#define	MYLV_COLUMN							LV_COLUMN
#define	MYLVITEM							LVITEM
#define	MYLVFINDINFO						LVFINDINFO

#define	MyListView_GetItem(hwnd,pitem)		\
	ListView_GetItem((hwnd),(pitem))
#define	MyListView_SetItem(hwnd,pitem)		\
	ListView_SetItem((hwnd),(pitem))
#define	MyListView_InsertItem(hwnd,pitem)	\
	ListView_InsertItem((hwnd),(pitem))
#define	MyListView_DeleteItem(hwnd,pitem)	\
	ListView_DeleteItem((hwnd),(pitem))
#define	MyListView_DeleteAllItems(hwnd)		\
	ListView_DeleteAllItems((hwnd))
#define	MyListView_FindItem(hwnd,iStart,plvfi)	\
	ListView_FindItem((hwnd),(iStart),(plvfi))
#define	MyListView_SetItemPosition(hwndLV,i,x,y)	\
	ListView_SetItemPosition((hwndLV),(i),(x),(y))
#define	MyListView_GetItemPosition(hwndLV,i,ppt)	\
	ListView_GetItemPosition((hwndLV),(i),(ppt))
#define	MyListView_GetStringWidth(hwnd,psz)	\
	ListView_GetStringWidth((hwnd),(psz))
#define	MyListView_HitTest(hwndLV,pinfo)	\
	ListView_HitText((hwndLV),(pinfo))
#define	MyListView_GetColumn(hwnd,iCol,pcol)	\
	ListView_GetColumn((hwnd),(iCol),(pcol))
#define	MyListView_SetColumn(hwnd,iCol,pcol)	\
	ListView_SetColumn((hwnd),(iCol),(pcol))
#define	MyListView_InsertColumn(hwnd,iCol,pcol)	\
	ListView_InsertColumn((hwnd),(iCol),(pcol))
#define	MyListView_GetColumnWidth(hwnd,iCol)	\
	ListView_GetColumnWidth((hwnd),(iCol))
#define	MyListView_SetColumnWidth(hwnd,iCol,cx)	\
	ListView_SetColumnWidth((hwnd),(iCol),(cx))
#define	MyListView_CreateDragImage(hwnd,i,lpptUpLeft)	\
	ListView_CreateDragImage((hwnd),(i),(lpptUpLeft))
#define	MyListView_Update(hwndLV,i)	\
	ListView_Update((hwndLV),(i))
#define	MyListView_SetItemState(hwndLV,i,data,mask)	\
	ListView_SetItemState((hwndLV),(i),(data),(mask))
#define	MyListView_GetItemText(hwndLV,i,iSubItem_,pszText_,cchTextMax_)	\
	ListView_GetItemText((hwndLV),(i),(iSubItem_),(pszText_),(cchTextMax_))
#define	MyListView_SetItemText(hwndLV,i,iSubItem_,pszText_)	\
	ListView_SetItemText((hwndLV),(i),(iSubItem_),(pszText_))
#define	MyListView_SetItemCount(hwndLV,cItems)	\
	ListView_SetItemCount((hwndLV),(citems))
#define	MyListView_SortItems(hwndLV,_pfnCompare,_lPrm)	\
	ListView_SortItems((hwndLV),(_pfnCompare),(_lPrm))
#define	MyListView_GetItemCount(hwnd) \
	ListView_GetItemCount((hwnd))

#endif
#endif

