#if !defined (skimconf_h)
#define	skimconf_h

#include "tmalloc.h"

/*	łƒ`ȂƁA͐ݒ_CAÔ߂
 *	R[hłȂ}[W̎ɒӁB
 */
#define	SKKSERV_DEFAULT_PORTNUM		(1178)

#define	MAX_INPUTVECTOR				(128)
#define	MAX_SKKIME_COLORFACE		(2)

#define	NUM_SHOWKEYICON				(3)

/*========================================================================
 *	Structures 
 */
typedef struct tagROMAKANATABLENODE {
	LPMYSTR			m_strPrefix ;
	LPMYSTR			m_strKana ;
	LPMYSTR			m_strKatakana ;
	int				m_chVowel ;
	struct tagROMAKANATABLENODE*	m_pPrev ;
	struct tagROMAKANATABLENODE*	m_pNext ;
}	ROMAKANATABLENODE ;

typedef struct tagPREFIXLISTNODE {
	LPMYSTR			m_strPrefix ;
	struct tagPREFIXLISTNODE*		m_pPrev ;
	struct tagPREFIXLISTNODE*		m_pNext ;
}	PREFIXLISTNODE ;

typedef struct tagSKKROMAKANARULENODE {
	LPMYSTR			m_strState ;
	LPMYSTR			m_strNext ;
	LPMYSTR			m_strHoutput ;
	LPMYSTR			m_strKoutput ;
	struct tagSKKROMAKANARULENODE*	m_pPrev ;
	struct tagSKKROMAKANARULENODE*	m_pNext ;
}	SKKROMAKANARULENODE ;

typedef struct tagPORTANDHOSTNODE {
	int				m_nPort ;
	LPMYSTR			m_strHost ;
	struct tagPORTANDHOSTNODE*		m_pPrev ;
	struct tagPORTANDHOSTNODE*		m_pNext ;
}	PORTANDHOSTNODE ;

typedef struct tagDICTNODE {
	int						m_nIndex ;
	int						m_nType ;
	PORTANDHOSTNODE*		m_lstHost ;
	LPMYSTR					m_strPath ;
	BOOL					m_fEnableAuxJisyo ;	// DICTYPE_SERVER only
	BOOL					m_fSortedAuxJisyo ;	// DICTYPE_SERVER only
	struct tagDICTNODE*		m_pPrev ;
	struct tagDICTNODE*		m_pNext ;
}	DICTNODE ;

typedef struct tagMYGENERICCONFIG {
	int				m_nAlwaysOpenKanaMode ;
	int				m_nEggLikeNewline ;
	int				m_nDeleteImpliesKakutei ;
	int				m_nUseNumericConversion ;
	int				m_nDabbrevLikeCompletion ;
	int				m_nKatakanaHiraganaHenkan ;
	int				m_nNumberStyle ;
	int				m_nDateAd ;
	int				m_nShowAnnotation ;
	int				m_nKakuteiEarly ;
	int				m_nProcessOkuriEarly ;
	int				m_nDeleteOkuriWhenQuit ;
}	MYGENERICCONFIG ;

#if !defined (NO_TSF)
typedef struct tagCICEROCONFIG {
	HWND			m_hwndEdit ;
	int				m_nEditingItem ;
	int				m_nEditingSubItem ;
	int				m_nEditTrue ;
	BOOL			m_rfShowLangBarIcon [NUM_SHOWKEYICON] ;
}	CICEROCONFIG ;
#endif

typedef struct tagMYCANDSELKEY {
	BYTE	_JHenkanShowCandidateKeys [NUM_JHENKAN_SHOW_CANDIDATE_KEYS] ;
	BYTE	_JInputByCodeOrMenuKeys1  [NUM_JINPUT_BY_CODE_OR_MENU_KEYS1] ;
	BYTE	_JInputByCodeOrMenuKeys2  [NUM_JINPUT_BY_CODE_OR_MENU_KEYS2] ;
}	MYCANDSELKEY ;

/*========================================================================
 *	prototypes 
 */
BOOL	skkimeConfig_main	(HINSTANCE, HWND, DWORD) ;
/*	confinpv.c */
BOOL	skkimeConfig_InitializeInputVector		(TINYMEMMGR*, LPMYSTR*) ;
BOOL	skkimeConfig_InitializeZenkakuVector	(TINYMEMMGR*, LPMYSTR*) ;
BOOL	skkimeConfig_UpdateInputVector			(LPMYSTR*) ;
BOOL	skkimeConfig_UpdateZenkakuVector		(LPMYSTR*) ;
/*	confkey.c */
BOOL	skkimeConfig_InitializeKeymap	(TINYMEMMGR*, BYTE*, BYTE*) ;
BOOL	skkimeConfig_UpdateKeymap		(BYTE*, BYTE*) ;
/*	confrmkt.c */
BOOL	skkimeConfig_InitializeRomaKanaTableA	(TINYMEMMGR*, ROMAKANATABLENODE**) ;
BOOL	skkimeConfig_InitializeRomaKanaTableI	(TINYMEMMGR*, ROMAKANATABLENODE**) ;
BOOL	skkimeConfig_InitializeRomaKanaTableU	(TINYMEMMGR*, ROMAKANATABLENODE**) ;
BOOL	skkimeConfig_InitializeRomaKanaTableE	(TINYMEMMGR*, ROMAKANATABLENODE**) ;
BOOL	skkimeConfig_InitializeRomaKanaTableO	(TINYMEMMGR*, ROMAKANATABLENODE**) ;
BOOL	skkimeConfig_UpdateRomaKanaTableA		(ROMAKANATABLENODE*) ;
BOOL	skkimeConfig_UpdateRomaKanaTableI		(ROMAKANATABLENODE*) ;
BOOL	skkimeConfig_UpdateRomaKanaTableU		(ROMAKANATABLENODE*) ;
BOOL	skkimeConfig_UpdateRomaKanaTableE		(ROMAKANATABLENODE*) ;
BOOL	skkimeConfig_UpdateRomaKanaTableO		(ROMAKANATABLENODE*) ;
/*	confrmkr.c */
BOOL	skkimeConfig_InitializeRomaKanaRuleList	(TINYMEMMGR*, SKKROMAKANARULENODE**) ;
BOOL	skkimeConfig_UpdateRomaKanaRuleList		(SKKROMAKANARULENODE*) ;
/*	confprfx.c */
BOOL	skkimeConfig_InitializePrefixList		(TINYMEMMGR*, PREFIXLISTNODE**) ;
BOOL	skkimeConfig_UpdatePrefixList			(PREFIXLISTNODE*) ;
/*	confdict.c */
BOOL	skkimeConfig_InitializeSearchJisyoList	(TINYMEMMGR*, DICTNODE**, LPMYSTR) ;
BOOL	skkimeConfig_UpdateSearchJisyoList		(DICTNODE*, LPMYSTR) ;
/*	confcol.c */
BOOL	skkimeConfig_InitializeColorFace		(TINYMEMMGR*, MYCOLORFACESET*) ;
BOOL	skkimeConfig_UpdateColorFace			(MYCOLORFACESET*) ;
/*	confgene.c */
BOOL	skkimeConfig_InitializeGeneric			(TINYMEMMGR*, MYGENERICCONFIG*) ;
BOOL	skkimeConfig_UpdateGeneric				(MYGENERICCONFIG*) ;
#if !defined (NO_TSF)
/*	confcicer.c */
BOOL	skkimeConfig_InitializeCICERO			(TINYMEMMGR*, CICEROCONFIG*) ;
BOOL	skkimeConfig_UpdateCICERO				(CICEROCONFIG*) ;
#endif
/*	confcsel.c */
BOOL	skkimeConfig_InitializeCandidateSelectKey	(TINYMEMMGR*, MYCANDSELKEY*) ;
BOOL	skkimeConfig_UpdateCandidateSelectKey		(MYCANDSELKEY*) ;

#endif

