// skimconf.cpp : AvP[ṼGg |Cg`܂B
//
#include "stdafx.h"
#include "skimconf.h"
#include "resource.h"
#include "keymap.h"
#include "TCommuSession.h"
#include "version.h"

#if !defined (ICC_STANDARD_CLASSES)
#define	ICC_STANDARD_CLASSES	0x4000
#endif

#define	MAX_PAGES		16

struct TPropPageSheetConfig {
	LPCTSTR			m_ptszTitle ;
	INT_PTR			(CALLBACK *m_pDialogProc)(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) ;
	int				m_nResId ;
} ;

static	BOOL				bNewPageSheet		(LPPROPSHEETHEADER, HINSTANCE, struct TPropPageSheetConfig*, void*) ;
static	int		CALLBACK	propSheetProc		(HWND, UINT, LPARAM) ;
extern	INT_PTR	CALLBACK	DlgGenericProc		(HWND, UINT, WPARAM, LPARAM) ;
extern	INT_PTR	CALLBACK	DlgKeybindProc		(HWND, UINT, WPARAM, LPARAM) ;
extern	INT_PTR	CALLBACK	DlgConversionProc	(HWND, UINT, WPARAM, LPARAM) ;
extern	INT_PTR	CALLBACK	DlgDictioanryProc	(HWND, UINT, WPARAM, LPARAM) ;
extern	INT_PTR	CALLBACK	DlgColorProc		(HWND, UINT, WPARAM, LPARAM) ;
extern	BOOL				dlgDictionary_bSyncSkkiserv (void) ;


static	struct TPropPageSheetConfig			_srPageSheetTbl []	= {
	{ TEXT("S"),							DlgGenericProc,			IDD_PROPPAGE_GENERIC, },
	{ TEXT("L[ݒ"),						DlgKeybindProc,			IDD_PROPPAGE_KEYBIND, },
	{ TEXT("ϊݒ"),						DlgConversionProc,		IDD_PROPPAGE_CONVERSION, },
	{ TEXT("ݒ"),						DlgDictioanryProc,		IDD_PROPPAGE_DICTIONARY, },
	{ TEXT("Fݒ"),						DlgColorProc,			IDD_PROPPAGE_COLOR, },
} ;

static	DWORD	_dwTick	= 0 ;

/*
 */
int	APIENTRY
_tWinMain (
	HINSTANCE	hInstance,
	HINSTANCE	hPrevInstance,
	LPTSTR		lpCmdLine,
	int			nCmdShow)
{
	UNREFERENCED_PARAMETER (hPrevInstance) ;
	UNREFERENCED_PARAMETER (lpCmdLine) ;

	// TODO: ɃR[h}ĂB
	INITCOMMONCONTROLSEX	initCtrls ;
	HPROPSHEETPAGE	rPages [MAX_PAGES] ;
	PROPSHEETHEADER	psh ;
	int		i ;
	HKEY	hSubKey ;
	DWORD	dwTick ;

	memset (&initCtrls, 0, sizeof (initCtrls)) ;
	initCtrls.dwSize	= sizeof (initCtrls) ;
	initCtrls.dwICC		= ICC_LISTVIEW_CLASSES | ICC_STANDARD_CLASSES ;
	InitCommonControlsEx (&initCtrls) ;

	psh.dwSize		= sizeof (psh) ;
	psh.dwFlags		= PSH_PROPTITLE | PSH_USECALLBACK ;
	psh.hwndParent	= NULL ;

	psh.hInstance	= hInstance ;
	psh.pszIcon		= NULL ;
	psh.pszCaption	= SKKIME_VERSION ;
	psh.nPages		= 0 ;
	psh.nStartPage	= 0 ;
	psh.phpage		= rPages ;
	psh.pfnCallback	= propSheetProc ;

	for (i = 0 ; i < ARRAYSIZE (_srPageSheetTbl) ; i ++) {
		if (! bNewPageSheet (&psh, psh.hInstance, &_srPageSheetTbl [i], NULL))
			return	FALSE ;
	}

	dwTick	= 0 ;
	if (RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_GENERIC, 0, KEY_READ, &hSubKey) == ERROR_SUCCESS) {
		DWORD	dwType, cbData ;
		LONG	lResult ;

		cbData	= sizeof (DWORD) ;
		lResult	= RegQueryValueExW (hSubKey, REGINFO_TICK, NULL, &dwType, (BYTE*)&dwTick, &cbData) ;
		RegCloseKey (hSubKey) ;
	}
	_dwTick	= dwTick ;

	(void) TCommunicateSession_bClassInit () ;
	if (psh.nPages > 0) {
		/* Tick  update B*/
		int	n = PropertySheet (&psh) ;

		if (n > 0) {
			vUpdateTick () ;
			dlgDictionary_bSyncSkkiserv () ;
		}
	}
	return	0 ;
}

BOOL
bNewPageSheet (
	LPPROPSHEETHEADER				ppsh,
	HINSTANCE						hInstance,
	struct TPropPageSheetConfig*	pConfig,
	void*							pvParam)
{
	PROPSHEETPAGE		psp ;

	/* ̃`FbNB*/
	if (ppsh == NULL || pConfig == NULL)
		return	FALSE ;
	if (ppsh->nPages >= MAX_PAGES)
		return	FALSE ;

	/* vpeBV[gɃy[WǉB*/
	psp.dwSize		= sizeof (psp) ;
	psp.dwFlags		= PSP_DEFAULT ; ;
	psp.hInstance	= hInstance ;
	psp.pszTemplate	= MAKEINTRESOURCE(pConfig->m_nResId) ;
	psp.pszIcon		= 0 ;
	psp.pfnDlgProc	= pConfig->m_pDialogProc ;
	psp.pfnCallback	= 0 ;
	psp.pszTitle	= pConfig->m_ptszTitle ;
	psp.lParam		= (LPARAM) pvParam ;
	ppsh->phpage [ppsh->nPages]	= CreatePropertySheetPage (&psp) ;
	if (ppsh->phpage [ppsh->nPages]){
		ppsh->nPages	++ ;
	}
	return	TRUE ;
}

int CALLBACK 
propSheetProc (
	HWND				hwnd,
	UINT				uMsg,
	LPARAM				lParam)
{
	switch (uMsg) {
	case	PSCB_INITIALIZED:
		break ;
	default:
		break ;
	}
	return	0 ;
}

/*========================================================================
 *	public functions
 */
static LPCTSTR		_srpFunctionNameTable []	= {
	TEXT ("self-insert-character"),
	TEXT ("set-mark-command"),
	TEXT ("beginning-of-line"),
	TEXT ("backward-char"),
//	TEXT ("mode-specific-command-prefix"),		/* @\B*/
	TEXT ("delete-char"),
	TEXT ("end-of-line"),
	TEXT ("foward-char"),
	TEXT ("keyboard-quit"),
	TEXT ("backward-delete-char"),
//	TEXT ("indent-for-tab-command"),			/* @\B*/
//	TEXT ("newline-and-indent"),				/* @\B*/
	TEXT ("kill-line"),
//	TEXT ("recenter"),							/* @\B*/
	TEXT ("newline"),
//	TEXT ("next-line"),							/* @\B*/
//	TEXT ("open-line"),							/* @\B*/
//	TEXT ("previous-line"),						/* @\B*/
//	TEXT ("quated-insert"),						/* @\B*/
//	TEXT ("isearch-backward"),					/* @\B*/
//	TEXT ("isearch-forward"),					/* @\B*/
	TEXT ("transpose-chars"),
//	TEXT ("universal-argument"),				/* @\B*/
//	TEXT ("scroll-up"),							/* @\B*/
	TEXT ("kill-region"),
//	TEXT ("control-x-prefix"),					/* @\B*/
	TEXT ("yank"),
//	TEXT ("scroll-down"),
//	TEXT ("prefix-command"),					/* @\B*/
	TEXT ("exit-recursive-edit"),
	TEXT ("abort-recursive-edit"),
//	TEXT ("undo"),								/* @\B*/
	TEXT ("toggle-ime"),

	/* skk  command */
	TEXT ("skk-insert"),
	TEXT ("skk-kakutei"),
	TEXT ("skk-start-henkan"),
	TEXT ("skk-try-completion"),
	TEXT ("skk-delete-backward-char"),
	TEXT ("skk-previous-candidate"),
	TEXT ("skk-toggle-characters"),
	TEXT ("skk-mode"),
	TEXT ("skk-latin-mode"),
	TEXT ("skk-jisx0208-latin-mode"),
	TEXT ("skk-set-henkan-point-subr"),
	TEXT ("skk-purge-from-jisyo"),
	TEXT ("skk-abbrev-mode"),
	TEXT ("skk-display-code-for-char-at-point"),
	TEXT ("skk-today"),
	TEXT ("skk-input-by-code-or-menu"),
//	TEXT ("skk-undo"),							/* @\B*/
	TEXT ("skk-comp-do"),
	TEXT ("skk-kakutei-henkan"),				/* H */
//	TEXT ("skk-undo-kakutei-henkan"),			/* @\B*/
	TEXT ("skk-jisx0208-latin-insert"),
	TEXT ("skk-latin-henkan"),
	TEXT ("skk-abbrev-comma"),
	TEXT ("skk-abbrev-period"),
	TEXT ("skk-toggle-kutouten"),

	/* non-interactive functions */
	TEXT ("skk-current-kuten"),
	TEXT ("skk-current-touten"),
	TEXT ("-"),
} ;

int
iShortStringCopy (
	LPWSTR		pszBuffer,
	int			nBufferSize,
	LPCWSTR		pwString,
	int			nStringLen)
{
	LPWSTR	pwDest, pwDestEnd ;
	LPCWSTR	pwSrc,	pwSrcEnd ;

	pwDest		= pszBuffer ;
	pwSrc		= pwString ;
	pwSrcEnd	= pwString + nStringLen ;
	if (nBufferSize < nStringLen) {
		pwDestEnd	= pszBuffer + nBufferSize - 3 ;
		while (pwDest < pwDestEnd && pwSrc < pwSrcEnd)
			*pwDest ++	= *pwSrc ++ ;
		pwDestEnd	= pszBuffer + nBufferSize ;
		pwSrc		= L"..." ;
		while (pwDest < pwDestEnd && *pwSrc != L'\0')
			*pwDest ++	= *pwSrc ++ ;
	} else {
		pwDestEnd	= pszBuffer + nBufferSize ;
		while (pwDest < pwDestEnd && pwSrc < pwSrcEnd)
			*pwDest ++	= *pwSrc ++ ;
	}
	return	pwDest - pszBuffer ;
}

int
iString2PrintableString (
	LPTSTR		pszBuffer,
	int			nBufferSize,
	LPCWSTR		pwString,
	int			nStringLen)
{
	LPCWSTR	pwSrc,  pwSrcEnd ;
	LPTSTR	pwDest, pwDestEnd ;

	pwDest		= pszBuffer ;
	pwDestEnd	= pszBuffer + nBufferSize ;
	pwSrc		= pwString ;
	pwSrcEnd	= pwString + nStringLen ;
#define	SAFE_COPY(dest,destend,chara)	if ((dest)<(destend)) { *(dest) = (chara) ; (dest) ++ ; }
	while (pwDest < pwDestEnd && pwSrc < pwSrcEnd) {
		if (*pwSrc <= 0x20 || *pwSrc == 0x7F) {
			SAFE_COPY (pwDest, pwDestEnd, TEXT ('\\')) ;
			if (*pwSrc >= 64)
				SAFE_COPY (pwDest, pwDestEnd, TEXT ('0') + (*pwSrc / 64)) ;
			if (*pwSrc >= 8)
				SAFE_COPY (pwDest, pwDestEnd, TEXT ('0') + (0x07 & (*pwSrc / 8))) ;
			SAFE_COPY (pwDest, pwDestEnd, TEXT ('0') + (0x07 & *pwSrc)) ;
		} else if (*pwSrc == TEXT ('\\')) {
			SAFE_COPY (pwDest, pwDestEnd, TEXT ('\\')) ;
			SAFE_COPY (pwDest, pwDestEnd, TEXT ('\\')) ;
		} else {
			SAFE_COPY (pwDest, pwDestEnd, *pwSrc) ;
		}
		pwSrc	++ ;
	}
#undef	SAFE_COPY
	if (pwDest < pwDestEnd)
		*pwDest	= TEXT ('\0') ;
	return	pwDest - pszBuffer ;
}


int
TestConfig_iKeyList2String (
	LPTSTR		pstrBuffer,
	int			nBufferSize,
	LPCWSTR		pwKey)
{
	TCHAR	szBuffer [64] ;
	LPTSTR	pDest ;
	LPCTSTR	pDestEnd ;
	LPTSTR	pSrc ;

	if (pwKey == NULL || pstrBuffer == NULL || nBufferSize <= 0)
		return	0 ;

	pDest		= pstrBuffer ;
	pDestEnd	= pstrBuffer + nBufferSize ;
	while (pDest < pDestEnd && *pwKey != TEXT ('\0')) {
		vKey2String (szBuffer, ARRAYSIZE (szBuffer), *pwKey) ;
		szBuffer [ARRAYSIZE (szBuffer) - 1]	= TEXT ('\0') ;

		pSrc	= szBuffer ;
		while (pSrc != TEXT ('\0') && pDest < pDestEnd) {
			*pDest ++	= *pSrc ++ ;
		}
		pwKey	++ ;
	}
	if (pDest < pDestEnd)
		*pDest	= TEXT ('\0') ;
	return	pDest - pstrBuffer ;
}

void
vKey2String (
	LPTSTR		pstrBuffer,
	int			nBufferSize,
	UINT		uKey)
{
	static LPCTSTR	rpFormat []	= {
		TEXT ("[%s]"), TEXT ("[C-%s]"), TEXT ("[S-%s]"),
	} ;

	if (/*0 <= uKey &&*/ uKey < 0x20) {
		wnsprintf (pstrBuffer, nBufferSize, TEXT ("\\C-%c"), TEXT ("@abcdefghijklmnopqrstuvwxyz[\\]^_") [uKey]) ;
		return ;
	}
	if (uKey == 0x20) {
		lstrcpyn (pstrBuffer, TEXT ("\\40"), nBufferSize) ;
		return ;
	}
	if (0x20 < uKey && uKey < 0x7F) {
		wnsprintf (pstrBuffer, nBufferSize, TEXT ("%c"), uKey) ;
		return ;
	}
	if (uKey == 0x7F) {
		lstrcpyn (pstrBuffer, TEXT ("\\177"), nBufferSize) ;
		return ;
	}
	/*
	if (0x80 <= uKey && uKey < SIZE_MYKEYMAP) {
		register int	nMajor, nMinor ;
		nMajor	= (uKey - 0x80) / NUM_BIND_PER_MYSPECIAL_KEY ;
		nMinor	= (uKey - 0x80) % NUM_BIND_PER_MYSPECIAL_KEY ;
		wsprintf (pstrBuffer, nBufferSize, rpFormat [nMinor], srVkKeyBinds [nMajor].m_pszText) ;
		return ;
	}
	*/
	lstrcpyn (pstrBuffer, TEXT ("undefined"), nBufferSize) ;
	return ;
}

void
vGetKeyFuncName (
	LPTSTR		pBuffer,
	int			nBufferSize,
	int			nFuncNo)
{
	if (pBuffer == NULL || nBufferSize <= 0)
		return ;

	if (0 <= nFuncNo && nFuncNo < ARRAYSIZE (_srpFunctionNameTable)) {
		int		n ;
		n	= lstrlen (_srpFunctionNameTable [nFuncNo]) ;
		if (n >= nBufferSize) {
			LPTSTR	pDest, pDestEnd ;
			LPCTSTR	pSrc ;

			pDest		= pBuffer ;
			pDestEnd	= pBuffer + nBufferSize - 4 ;
			pSrc		= _srpFunctionNameTable [nFuncNo] ;
			while (pDest < pDestEnd && *pSrc != TEXT ('\0'))
				*pDest ++	= *pSrc ++ ;

			pSrc		= TEXT ("...") ;
			pDestEnd	= pBuffer + nBufferSize ;
			while (pDest < pDestEnd && *pSrc != TEXT ('\0'))
				*pDest ++	= *pSrc ++ ;
			if (pDest < pDestEnd)
				*pDest = TEXT ('\0') ;
		} else {
			lstrcpyn (pBuffer, _srpFunctionNameTable [nFuncNo], nBufferSize) ;
		}
	}  else {
		if (nFuncNo != NFUNC_INVALID_CHAR) {
			pBuffer [0]	= TEXT ('\0') ;
		} else {
			lstrcpyn (pBuffer, TEXT ("-"), nBufferSize) ;
		}
	}
	return ;
}

BOOL
EnableDlgItem (
	HWND		hDlg,
	int			nResId,
	BOOL		fEnable)
{
	HWND	hwndCtl ;

	hwndCtl	= GetDlgItem (hDlg, nResId) ;
	if (hwndCtl == NULL)
		return	FALSE ;
	EnableWindow (hwndCtl, fEnable) ;
	return	TRUE ;
}

BOOL
SetDropDownListCurrentSelectionByData (
	HWND		hDlg,
	int			nResId,
	int			nData)
{
	HWND	hwndControl ;
	int		nItemCount, i, nValue ;

	hwndControl	= GetDlgItem (hDlg, nResId) ;
	if (hwndControl == NULL)
		return	FALSE ;
	nItemCount	= SendMessage (hwndControl, CB_GETCOUNT, (WPARAM) 0, (LPARAM) 0) ;
	if (nItemCount == CB_ERR)
		return	FALSE ;
	for (i = 0 ; i < nItemCount ; i ++) {
		nValue	= SendMessage (hwndControl, CB_GETITEMDATA, (WPARAM) i, (LPARAM) 0) ;
		if (nValue != CB_ERR && nValue == nData) {
			return	(SendMessage (hwndControl, CB_SETCURSEL, (WPARAM) i, (LPARAM) 0) != CB_ERR) ;
		}
	}
	SendMessage (hwndControl, CB_SETCURSEL, (WPARAM) -1, (LPARAM) 0) ;
	return	FALSE ;
}

BOOL
IsRadioButtonChecked (
	HWND		hDlg,
	int			nRadioIdStart,
	int			nRadioIdEnd,
	int			nRadioId)
{
	int		nIDButton ;

	for (nIDButton = nRadioIdStart ; nIDButton <= nRadioIdEnd ; nIDButton ++) {
		if (nIDButton == nRadioId)
			continue ;
		if (IsDlgButtonChecked (hDlg, nIDButton) != BST_UNCHECKED)
			return	FALSE ;
	}
	return	TRUE ;
}

BOOL
bCreateRegistryKey (
	LPCTSTR		pstrSubKey,
	BOOL		fClean,
	HKEY*		phKey)
{
	HKEY	hSubKey ;
	DWORD	dwDispose ;
	LONG	lResult ;

	if (pstrSubKey == NULL || phKey == NULL)
		return	FALSE ;

	if (fClean) {
		lResult	= RegDeleteKey (HKEY_CURRENT_USER, pstrSubKey) ;
	}
	if (RegCreateKeyEx (HKEY_CURRENT_USER, pstrSubKey, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ | KEY_WRITE, NULL, &hSubKey, &dwDispose) != ERROR_SUCCESS) {
		return	FALSE ;
	}
	*phKey	= hSubKey ;
	return	TRUE ;
}

int
iPopupMenu (
	HWND					hwndOwner,
	const struct TMENUITEM*	pMenuItem,
	int						nMenuItem)
{
	HMENU				hMenu	= CreatePopupMenu () ;
	static MENUITEMINFO	mmi ;
	POINT				pt ;
	int					i, n ;

	memset (&mmi, 0, sizeof (mmi)) ;
	mmi.cbSize	= sizeof (mmi) ;
	for (i = 0 ; i < nMenuItem ; i ++) {
#if(WINVER >= 0x0500)
		mmi.fMask		= pMenuItem->m_fMask ;
#else
		mmi.fMask		= pMenuItem->m_fMask | 0x00000140 ;
#endif
		mmi.fType		= pMenuItem->m_fType ;
		mmi.dwTypeData	= (LPTSTR) pMenuItem->m_strText ;
		mmi.wID			= pMenuItem->m_wID ;
		mmi.fState		= pMenuItem->m_fState ;
		mmi.cch			= lstrlen (pMenuItem->m_strText) ;
		InsertMenuItem (hMenu, i, TRUE, &mmi) ;
		pMenuItem	++ ;
	}
	if (! GetCursorPos (&pt)) 
		pt.x	= pt.y	= 0 ;
	n	= TrackPopupMenu (hMenu, TPM_RETURNCMD | TPM_RIGHTBUTTON, pt.x, pt.y, 0, hwndOwner, NULL) ;
	DestroyMenu (hMenu) ;
	return	n ;
}

BOOL
bParseBSEncodedString (
	LPCTSTR*	ppwSrc,
	LPTSTR		pwDest,
	int			nDestSize,
	BOOL*		pbTerminated)
{
	LPCTSTR	pwSrc ;
	LPTSTR	pwDestLast ;
	int		nCH ;

	pwSrc		= *ppwSrc ;
	pwDestLast	= pwDest + nDestSize ;
	while (*pwSrc != TEXT ('\0') && pwDest < pwDestLast) {
		if (*pwSrc == TEXT ('\\')) {
			pwSrc	++ ;
			nCH		= *pwSrc ;
			if (nCH == TEXT ('\0')) {
				break ;
			} else if (nCH == TEXT ('0')) {
				/* I[B*/
				pwSrc ++ ;
				break ;
			} else {
				*pwDest ++	= nCH ;
			}
		} else {
			*pwDest ++	= *pwSrc ;
		}
		pwSrc	++ ;
	}
	if (pwDest < pwDestLast)
		*pwDest	= TEXT ('\0') ;
	*pbTerminated	= (*pwSrc == TEXT ('\0')) ;
	*ppwSrc			= pwSrc ;
	return	TRUE ;
}

int
iCountBSEncodedString (
	LPCTSTR		strString)
{
	LPCTSTR		pwSrc ;
	int			nCount ;

	nCount	= 0 ;
	if (strString != NULL) {
		pwSrc	= strString ;
		while (*pwSrc != TEXT ('\0')) {
			nCount	+= (*pwSrc == TEXT ('\\'))? 2 : 1 ;
			pwSrc	++ ;
		}
	}
	return	nCount ;
}

int
iBSEncodeString (
	LPTSTR		pwDest,
	LPCTSTR		pwSrc)
{
	LPTSTR	pwDestBak ;

	if (pwSrc == NULL)
		return	0 ;

	pwDestBak	= pwDest ;
	while (*pwSrc != TEXT ('\0')) {
		if (*pwSrc == TEXT ('\\')) {
			*pwDest ++	= TEXT ('\\') ;
			*pwDest ++	= TEXT ('\\') ;
		} else {
			*pwDest ++	= *pwSrc ;
		}
		pwSrc	++ ;
	}
	return	(pwDest - pwDestBak) ;
}

void
vUpdateTick (void)
{
	HKEY	hKey ;

	_dwTick	++ ;
	if (bCreateRegistryKey (REGPATH_GENERIC, FALSE, &hKey)) {
		(void) RegSetValueEx (hKey, REGINFO_TICK, 0, REG_DWORD, (BYTE*) &_dwTick, sizeof (DWORD)) ;
		RegCloseKey (hKey) ;
	}
	return ;
}

#if 0



#include "stdafx.h"
#include "skimconf.h"

#define MAX_LOADSTRING 100

// O[oϐ:
static	HINSTANCE	hInst ;									// ݂̃C^[tFCX
static	TCHAR		szTitle			[MAX_LOADSTRING] ;		// ^Cg o[̃eLXg
static	TCHAR		szWindowClass	[MAX_LOADSTRING] ;		// C EBhE NX





// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);




int APIENTRY
_tWinMain (
	HINSTANCE	hInstance,
	HINSTANCE	hPrevInstance,
	LPTSTR		lpCmdLine,
	int			nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB



	MSG		msg ;
	HACCEL	hAccelTable ;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SKIMCONF, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance) ;

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_SKIMCONF));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_SKIMCONF));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_SKIMCONF);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
#endif

